// Graph2D.h : Declaration of the CGraph2D

#ifndef __GRAPH2D_H_
#define __GRAPH2D_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include <graphwnd.h>

class CGraph2D;

typedef CWindowImpl < CGraph2D, CGraphWnd >	MFCWndImpl;
typedef CComControl< CGraph2D, MFCWndImpl >	MFCComCtrl;

/////////////////////////////////////////////////////////////////////////////
// CGraph2D
class ATL_NO_VTABLE CGraph2D : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IGraph2D, &IID_IGraph2D, &LIBID_GRAPH2DPROJLib>,
	public MFCComCtrl,
	public IPersistStreamInitImpl<CGraph2D>,
	public IOleControlImpl<CGraph2D>,
	public IOleObjectImpl<CGraph2D>,
	public IOleInPlaceActiveObjectImpl<CGraph2D>,
	public IViewObjectExImpl<CGraph2D>,
	public IOleInPlaceObjectWindowlessImpl<CGraph2D>,
	public IPersistStorageImpl<CGraph2D>,
	public ISpecifyPropertyPagesImpl<CGraph2D>,
	public IQuickActivateImpl<CGraph2D>,
	public IDataObjectImpl<CGraph2D>,
	public IProvideClassInfo2Impl<&CLSID_Graph2D, NULL, &LIBID_GRAPH2DPROJLib>,
	public CComCoClass<CGraph2D, &CLSID_Graph2D>
{
public:
	CGraph2D()
	{
		m_bWindowOnly = TRUE;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_GRAPH2D)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CGraph2D)
	COM_INTERFACE_ENTRY(IGraph2D)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CGraph2D)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CGraph2D)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	CHAIN_MSG_MAP( MFCComCtrl );
    DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)


   	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
        m_bAutoUpdateTimer = FALSE;
        CGraphWnd::OnCreate(NULL);

        return 0;
	}


	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip)
	{
		IOleInPlaceObjectWindowlessImpl<CGraph2D>::SetObjectRects(prcPos, prcClip);
        CGraphWnd::OnMove( prcPos->left, prcPos->top );
        CGraphWnd::OnSize( SIZE_RESTORED, prcPos->right - prcPos->left, prcPos->bottom - prcPos->top );
		return S_OK;
	}



// IGraph2D
public:
	STDMETHOD(get_GraphTitle)       (/*[in]*/ LONG graphindex, /*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_GraphTitle)       (/*[in]*/ LONG graphindex, /*[in]*/ BSTR newVal);
	STDMETHOD(get_GraphColor)       (/*[in]*/ LONG graphindex, /*[out, retval]*/ COLORREF *pVal);
	STDMETHOD(put_GraphColor)       (/*[in]*/ LONG graphindex, /*[in]*/ COLORREF newVal);
	STDMETHOD(get_GraphIsVisible)   (/*[in]*/LONG graphindex, /*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_GraphIsVisible)   (/*[in]*/LONG graphindex, /*[in]*/ BOOL newVal);
	STDMETHOD(get_WorldCoordsY2)    (/*[out, retval]*/ DOUBLE *pVal);
	STDMETHOD(put_WorldCoordsY2)    (/*[in]*/ DOUBLE newVal);
	STDMETHOD(get_WorldCoordsY1)    (/*[out, retval]*/ DOUBLE *pVal);
	STDMETHOD(put_WorldCoordsY1)    (/*[in]*/ DOUBLE newVal);
	STDMETHOD(get_WorldCoordsX2)    (/*[out, retval]*/ DOUBLE *pVal);
	STDMETHOD(put_WorldCoordsX2)    (/*[in]*/ DOUBLE newVal);
	STDMETHOD(get_WorldCoordsX1)    (/*[out, retval]*/ DOUBLE *pVal);
	STDMETHOD(put_WorldCoordsX1)    (/*[in]*/ DOUBLE newVal);
	STDMETHOD(get_BoundRectMaxY)    (/*[out, retval]*/ DOUBLE *pVal);
	STDMETHOD(get_BoundRectMinY)    (/*[out, retval]*/ DOUBLE *pVal);
	STDMETHOD(get_BoundRectMaxX)    (/*[out, retval]*/ DOUBLE *pVal);
	STDMETHOD(get_BoundRectMinX)    (/*[out, retval]*/ DOUBLE *pVal);
	STDMETHOD(get_YAxisPrecision)   (/*[out, retval]*/ LONG *pVal);
	STDMETHOD(put_YAxisPrecision)   (/*[in]*/ LONG newVal);
	STDMETHOD(get_XAxisPrecision)   (/*[out, retval]*/ LONG *pVal);
	STDMETHOD(put_XAxisPrecision)   (/*[in]*/ LONG newVal);
	STDMETHOD(get_YAxisUOM)         (/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_YAxisUOM)         (/*[in]*/ BSTR newVal);
	STDMETHOD(get_XAxisUOM)         (/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_XAxisUOM)         (/*[in]*/ BSTR newVal);
	STDMETHOD(get_YAxisTitle)       (/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_YAxisTitle)       (/*[in]*/ BSTR newVal);
	STDMETHOD(get_XAxisTitle)       (/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_XAxisTitle)       (/*[in]*/ BSTR newVal);
	STDMETHOD(get_GraphScatter)     (/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_GraphScatter)     (/*[in]*/ BOOL newVal);
	STDMETHOD(get_GraphDrawAxis)    (/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_GraphDrawAxis)    (/*[in]*/ BOOL newVal);
	STDMETHOD(get_GraphShowTooltips)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_GraphShowTooltips)(/*[in]*/ BOOL newVal);
	STDMETHOD(get_GraphSquarePoints)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_GraphSquarePoints)(/*[in]*/ BOOL newVal);
	STDMETHOD(get_GraphAutoScale)   (/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(put_GraphAutoScale)   (/*[in]*/ BOOL newVal);
	STDMETHOD(get_GraphCount)       (/*[out, retval]*/ long *pVal);
	STDMETHOD(DrawGraphToDC)        (/*[in]*/ LONG *hDC, /*[in]*/ DOUBLE x1, /*[in]*/ DOUBLE x2, /*[in]*/ DOUBLE y1, /*[in]*/ DOUBLE y2);
	STDMETHOD(OperateWithPointView) (/*[in]*/ ULONG pview_operations);
	STDMETHOD(UpdateWindows)        (/*[in]*/ ULONG what_to_update);
	STDMETHOD(FormatAxisOutput)     (/*[in]*/ DOUBLE value, /*[in]*/ BOOL bXAxis, /*[in]*/ LONG format_level, /*[out,retval]*/ BSTR * res_str);
    STDMETHOD(ClearGraph)           (/*[in]*/ LONG graphnum, /*[in,optional]*/ BOOL bRedraw);
	STDMETHOD(RemovePoint)          (/*[in]*/ LONG graphnum, /*[in]*/ LONG index, /*[in,optional]*/ BOOL bRedraw);
	STDMETHOD(EditPoint)            (/*[in]*/ LONG graphnum, /*[in]*/ LONG index, /*[in]*/ DOUBLE x, /*[in]*/ DOUBLE y, /*[in,optional]*/ BOOL bRedraw, /*[out,retval]*/ LONG * res);
	STDMETHOD(AddPoint)             (/*[in]*/ LONG graphnum, /*[in]*/ DOUBLE x, /*[in]*/ DOUBLE y, /*[in,optional]*/ BOOL bRedraw, /*[in,optional]*/ LONG index);
    STDMETHOD(RemoveGraph)          (/*[in]*/ LONG index, /*[in,optional]*/ BOOL bRedraw);
    STDMETHOD(AddGraph)             (/*[in,optional]*/ COLORREF newColor, /*[in,optional]*/ BSTR title, /*[in,optional]*/ BOOL bRedraw, /*[in,optional]*/ BOOL b_sort_x, /*[in,optional]*/ BOOL b_keep_same_x, /*[retval,out]*/ LONG *index);
};

#endif //__GRAPH2D_H_
